%global __strip %{mingw_strip}
%global __objdump %{mingw_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{mingw_findrequires}
%global __find_provides %{mingw_findprovides}
%define __debug_install_post %{mingw_debug_install_post}

%global mingw_pkg_name gstreamer-plugins-bad
%global mingw_build_win32 1
%global mingw_build_win64 1

%define         gstreamer       gstreamer
%define         majorminor      0.10
%define         gstreamer_version %{majorminor}.33

Name:           mingw-gstreamer-plugins-bad
Version:        0.10.22
Release:        1%{?dist}
Summary:        Cross compiled GStreamer plug-ins "bad"

# The freeze and nfs plugins are LGPLv2 (only)
Group:          Applications/Multimedia
License:        LGPLv2+ and LGPLv2
URL:            http://gstreamer.freedesktop.org/
Source:         http://gstreamer.freedesktop.org/src/gst-plugins-bad/gst-plugins-bad-free-%{version}.tar.bz2
#Source:         http://gstreamer.freedesktop.org/src/gst-plugins-bad/gst-plugins-bad-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Patch1:		0001-gst-dccp-fix-build-on-newer-mingw.patch

BuildArch:      noarch

BuildRequires:  mingw-filesystem >= 65
BuildRequires:  mingw32-gcc
BuildRequires:  mingw64-gcc
BuildRequires:  mingw32-gstreamer >= %{gst_minver}
BuildRequires:  mingw32-gstreamer-plugins-base >= %{gstpb_minver}
BuildRequires:  mingw32-gettext
BuildRequires:  mingw64-gettext
BuildRequires:  mingw32-orc
BuildRequires:  mingw64-orc
BuildRequires:  mingw32-pthreads
BuildRequires:  mingw64-pthreads
#BuildRequires: mingw32-libcelt

%{?mingw_default_requires}
%{?mingw_debug_package}

%description
GStreamer is a streaming media framework, based on graphs of elements which
operate on media data.

This package contains plug-ins that aren't tested
well enough, or the code is not of good enough quality.


# Mingw32
%package -n mingw32-%{mingw_pkg_name}
Summary:        %{summary}
Requires:       mingw32-gstreamer >= %{gst_minver}

%description -n mingw32-%{mingw_pkg_name}
GStreamer is a streaming media framework, based on graphs of elements which
operate on media data.

This package contains plug-ins that aren't tested
well enough, or the code is not of good enough quality.

%package -n mingw32-%{mingw_pkg_name}-static
Summary:        Static libraries for the GStreamer plug-ins "bad"
Group:          Development/Libraries
Requires:       mingw32-%{mingw_pkg_name} = %{version}-%{release}

%description -n mingw32-%{mingw_pkg_name}-static
Static version of the cross compiled GStreamer plug-ins "bad".

# Mingw64
%package -n mingw64-%{mingw_pkg_name}
Summary:        %{summary}
Requires:       mingw64-gstreamer >= %{gst_minver}

%description -n mingw64-%{mingw_pkg_name}
GStreamer is a streaming media framework, based on graphs of elements which
operate on media data.

This package contains plug-ins that aren't tested
well enough, or the code is not of good enough quality.

%package -n mingw64-%{mingw_pkg_name}-static
Summary:        Static libraries for the GStreamer plug-ins "bad"
Group:          Development/Libraries
Requires:       mingw64-%{mingw_pkg_name} = %{version}-%{release}

%description -n mingw64-%{mingw_pkg_name}-static
Static version of the cross compiled GStreamer plug-ins "bad".


%prep
%setup -q -n gst-plugins-bad-%{version}
%patch1 -p1

%build
%mingw_configure "--with-package-name='Fedora Mingw gstreamer-plugins-bad package'" "--with-package-origin='http://download.fedora.redhat.com/fedora'" "--enable-debug" "--disable-gtk-doc" "--enable-experimental" "--disable-divx" "--disable-acm" "--disable-apexsink" "--disable-dvdspu" "--disable-real" "--disable-siren"

%mingw_make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
%mingw_make_install DESTDIR=$RPM_BUILD_ROOT

# Clean out files that should not be part of the rpm.
rm -f $RPM_BUILD_ROOT%{mingw32_libdir}/gstreamer-%{majorminor}/*.la
rm -f $RPM_BUILD_ROOT%{mingw64_libdir}/gstreamer-%{majorminor}/*.la
rm -f $RPM_BUILD_ROOT%{mingw32_libdir}/gstreamer-%{majorminor}/*.a
rm -f $RPM_BUILD_ROOT%{mingw64_libdir}/gstreamer-%{majorminor}/*.a

%find_lang %{mingw_pkg_name} --all-name

%clean
rm -rf $RPM_BUILD_ROOT


# Mingw32
%files -n mingw32-%{mingw_pkg_name} -f %{mingw_pkg_name}.lang
%defattr(-,root,root,-)
%doc AUTHORS COPYING README REQUIREMENTS

# libraries
%{mingw32_bindir}/libgstbasecamerabinsrc-%{majorminor}-0.dll
%{mingw32_bindir}/libgstbasevideo-%{majorminor}-0.dll
%{mingw32_bindir}/libgstphotography-%{majorminor}-0.dll
%{mingw32_bindir}/libgstsignalprocessor-%{majorminor}-0.dll

# bad plugins
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstadpcmdec.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstadpcmenc.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstaiff.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstasfmux.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstautoconvert.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstbayer.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstcamerabin.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstcamerabin2.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstcdxaparse.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstcog.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstcoloreffects.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstcolorspace.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstdataurisrc.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstdccp.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstdebugutilsbad.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstdirectdrawsink.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstdirectsoundsrc.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstdtmf.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstdvbsuboverlay.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstfestival.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstfieldanalysis.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstfragmented.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstfreeze.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstfrei0r.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstgaudieffects.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstgeometrictransform.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstgsettingselements.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgsth264parse.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgsthdvparse.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstid3tag.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstinterlace.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstinvtelecine.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstivfparse.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstjp2k.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstjp2kdecimator.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstjpegformat.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstlegacyresample.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstliveadder.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstmpeg4videoparse.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstmpegdemux.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstmpegpsmux.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstmpegtsdemux.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstmpegtsmux.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstmpegvideoparse.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstmve.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstmxf.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstnsf.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstnuvdemux.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstpatchdetect.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstpcapparse.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstpnm.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstrawparse.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstrfbsrc.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstrtpmux.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstrtpvp8.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstscaletempoplugin.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstsdi.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstsdl.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstsdpelem.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstsegmentclip.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstspeed.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgststereo.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstsubenc.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgsttta.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstvideofiltersbad.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstvideomaxrate.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstvideomeasure.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstvideoparsersbad.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstvideosignal.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstvmnc.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgsty4mdec.dll

# %files devel
# plugin helper library headers
%dir %{mingw32_includedir}/gstreamer-%{majorminor}/gst/interfaces
%{mingw32_includedir}/gstreamer-%{majorminor}/gst/basecamerabinsrc/gstbasecamerasrc.h
%{mingw32_includedir}/gstreamer-%{majorminor}/gst/basecamerabinsrc/gstcamerabin-enum.h
%{mingw32_includedir}/gstreamer-%{majorminor}/gst/basecamerabinsrc/gstcamerabinpreview.h
%{mingw32_includedir}/gstreamer-%{majorminor}/gst/interfaces/photography-enumtypes.h
%{mingw32_includedir}/gstreamer-%{majorminor}/gst/interfaces/photography.h
%{mingw32_includedir}/gstreamer-%{majorminor}/gst/signalprocessor/gstsignalprocessor.h
%{mingw32_includedir}/gstreamer-%{majorminor}/gst/video/gstbasevideocodec.h
%{mingw32_includedir}/gstreamer-%{majorminor}/gst/video/gstbasevideodecoder.h
%{mingw32_includedir}/gstreamer-%{majorminor}/gst/video/gstbasevideoencoder.h

%{mingw32_libdir}/libgstbasecamerabinsrc-%{majorminor}.dll.a
%{mingw32_libdir}/libgstbasecamerabinsrc-%{majorminor}.la
%{mingw32_libdir}/libgstbasevideo-%{majorminor}.dll.a
%{mingw32_libdir}/libgstbasevideo-%{majorminor}.la
%{mingw32_libdir}/libgstphotography-%{majorminor}.dll.a
%{mingw32_libdir}/libgstphotography-%{majorminor}.la
%{mingw32_libdir}/libgstsignalprocessor-%{majorminor}.dll.a
%{mingw32_libdir}/libgstsignalprocessor-%{majorminor}.la

%{mingw32_libdir}/pkgconfig/gstreamer-plugins-bad-0.10.pc
%{mingw32_datadir}/glib-2.0/schemas/org.freedesktop.gstreamer-0.10.default-elements.gschema.xml

%files -n mingw32-%{mingw_pkg_name}-static
%defattr(-, root, root)
%{mingw32_libdir}/libgstbasecamerabinsrc-%{majorminor}.a
%{mingw32_libdir}/libgstbasevideo-%{majorminor}.a
%{mingw32_libdir}/libgstphotography-%{majorminor}.a
%{mingw32_libdir}/libgstsignalprocessor-%{majorminor}.a

# Mingw64
%files -n mingw64-%{mingw_pkg_name} -f %{mingw_pkg_name}.lang
%defattr(-,root,root,-)
%doc AUTHORS COPYING README REQUIREMENTS

# libraries
%{mingw64_bindir}/libgstbasecamerabinsrc-%{majorminor}-0.dll
%{mingw64_bindir}/libgstbasevideo-%{majorminor}-0.dll
%{mingw64_bindir}/libgstphotography-%{majorminor}-0.dll
%{mingw64_bindir}/libgstsignalprocessor-%{majorminor}-0.dll

# bad plugins
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstadpcmdec.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstadpcmenc.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstaiff.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstasfmux.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstautoconvert.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstbayer.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstcamerabin.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstcamerabin2.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstcdxaparse.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstcog.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstcoloreffects.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstcolorspace.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstdataurisrc.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstdccp.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstdebugutilsbad.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstdirectdrawsink.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstdirectsoundsrc.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstdtmf.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstdvbsuboverlay.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstfestival.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstfieldanalysis.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstfragmented.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstfreeze.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstfrei0r.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstgaudieffects.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstgeometrictransform.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstgsettingselements.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgsth264parse.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgsthdvparse.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstid3tag.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstinterlace.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstinvtelecine.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstivfparse.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstjp2k.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstjp2kdecimator.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstjpegformat.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstlegacyresample.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstliveadder.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstmpeg4videoparse.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstmpegdemux.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstmpegpsmux.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstmpegtsdemux.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstmpegtsmux.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstmpegvideoparse.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstmve.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstmxf.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstnsf.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstnuvdemux.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstpatchdetect.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstpcapparse.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstpnm.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstrawparse.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstrfbsrc.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstrtpmux.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstrtpvp8.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstscaletempoplugin.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstsdi.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstsdl.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstsdpelem.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstsegmentclip.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstspeed.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgststereo.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstsubenc.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgsttta.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstvideofiltersbad.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstvideomaxrate.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstvideomeasure.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstvideoparsersbad.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstvideosignal.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstvmnc.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgsty4mdec.dll

# %files devel
# plugin helper library headers
%dir %{mingw64_includedir}/gstreamer-%{majorminor}/gst/interfaces
%{mingw64_includedir}/gstreamer-%{majorminor}/gst/basecamerabinsrc/gstbasecamerasrc.h
%{mingw64_includedir}/gstreamer-%{majorminor}/gst/basecamerabinsrc/gstcamerabin-enum.h
%{mingw64_includedir}/gstreamer-%{majorminor}/gst/basecamerabinsrc/gstcamerabinpreview.h
%{mingw64_includedir}/gstreamer-%{majorminor}/gst/interfaces/photography-enumtypes.h
%{mingw64_includedir}/gstreamer-%{majorminor}/gst/interfaces/photography.h
%{mingw64_includedir}/gstreamer-%{majorminor}/gst/signalprocessor/gstsignalprocessor.h
%{mingw64_includedir}/gstreamer-%{majorminor}/gst/video/gstbasevideocodec.h
%{mingw64_includedir}/gstreamer-%{majorminor}/gst/video/gstbasevideodecoder.h
%{mingw64_includedir}/gstreamer-%{majorminor}/gst/video/gstbasevideoencoder.h

%{mingw64_libdir}/libgstbasecamerabinsrc-%{majorminor}.dll.a
%{mingw64_libdir}/libgstbasecamerabinsrc-%{majorminor}.la
%{mingw64_libdir}/libgstbasevideo-%{majorminor}.dll.a
%{mingw64_libdir}/libgstbasevideo-%{majorminor}.la
%{mingw64_libdir}/libgstphotography-%{majorminor}.dll.a
%{mingw64_libdir}/libgstphotography-%{majorminor}.la
%{mingw64_libdir}/libgstsignalprocessor-%{majorminor}.dll.a
%{mingw64_libdir}/libgstsignalprocessor-%{majorminor}.la

%{mingw64_libdir}/pkgconfig/gstreamer-plugins-bad-0.10.pc
%{mingw64_datadir}/glib-2.0/schemas/org.freedesktop.gstreamer-0.10.default-elements.gschema.xml

%files -n mingw64-%{mingw_pkg_name}-static
%defattr(-, root, root)
%{mingw64_libdir}/libgstbasecamerabinsrc-%{majorminor}.a
%{mingw64_libdir}/libgstbasevideo-%{majorminor}.a
%{mingw64_libdir}/libgstphotography-%{majorminor}.a
%{mingw64_libdir}/libgstsignalprocessor-%{majorminor}.a


%changelog
* Sat May 14 2011 - Marc-André Lureau <marcandre.lureau@redhat.com> - 0.10.22-1
- Updated to 0.10.22
- Updated to newer mingw instructions (with mingw64 support)

* Tue Jan 04 2011 - Marc-André Lureau <marcandre.lureau@redhat.com> - 0.10.20-1
- Build with mingw32
